diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/NeighborUpdates.java b/game/core/src/main/java/net/minecraft/core/util/helper/NeighborUpdates.java
new file mode 100644
index 000000000..70b8a9291
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/NeighborUpdates.java
@@ -0,0 +1,351 @@
+package net.minecraft.core.util.helper;
+
+import java.util.Set;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import it.unimi.dsi.fastutil.objects.ObjectOpenHashSet;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+
+public abstract class NeighborUpdates {
+    private NeighborUpdates() {}
+
+    private static final Direction Xn = Direction.WEST;
+    private static final Direction Xp = Direction.EAST;
+    private static final Direction Yn = Direction.DOWN;
+    private static final Direction Yp = Direction.UP;
+    private static final Direction Zn = Direction.NORTH;
+    private static final Direction Zp = Direction.SOUTH;
+
+    private static final @NotNull Direction[] D1_OFFSETS = { Xn, Xp, Yn, Yp, Zn, Zp };
+
+    /**
+     * updates blocks adjascent to the origin with the order -x, +x, -y, +y, -z, +z
+     */
+    public static void diamondD1(@NotNull World world, @NotNull TilePosc pos, @Nullable Block<?> block) {
+        diamondD1(null, world, pos, block);
+    }
+
+    public static void diamondD1(
+        @Nullable Set<@NotNull TilePosc> updatedPositions,
+        @NotNull World world, @NotNull TilePosc pos, @Nullable Block<?> block
+    ) {
+        final boolean dedupe = updatedPositions != null;
+        if (block == null) block = world.getBlockType(pos);
+
+        final var qpos = new TilePos();
+        for (var d : D1_OFFSETS) {
+            qpos.set(pos).add(d);
+
+            if (dedupe) {
+                if (updatedPositions.contains(qpos)) continue;
+                updatedPositions.add(new TilePos(qpos));
+            }
+
+            final var block1 = world.getBlockType(qpos);
+            block1.onNeighborChanged(world, qpos, block);
+        }
+    }
+
+    private static final @NotNull Direction[] @NotNull[] D2_OFFSETS = {
+        /* Xn */ { Xn, Yp, Yn, Zp, Zn },
+        /* Xp */ { Xp, Yp, Yn, Zp, Zn },
+        /* Yn */ { Yn, Zp, Zn },
+        /* Yp */ { Yp, Zp, Zn },
+        /* Zn */ { Zn },
+        /* Zp */ { Zp },
+    };
+
+    /**
+     * updates each block within the range |x| + |y| + |z| <= 2, excluding the origin.
+     * blocks in the inner shell are updated with the origin as the source,
+     * blocks in the outer shell are updated with block from the inner shell as the source,
+     * prioritizing inner shell blocks from -x, +x, -y, +y, -z, +z.
+     */ 
+    public static void diamondD2(@NotNull World world, @NotNull TilePosc pos, @Nullable Block<?> block) {
+        diamondD2(null, world, pos, block);
+    }
+
+    public static synchronized void diamondD2(
+        @Nullable Set<@NotNull TilePosc> updatedPositions,
+        @NotNull World world, @NotNull TilePosc pos, @Nullable Block<?> block
+    ) {
+        // class ctx { static final Block<?>[] D1_BLOCKS = new Block<?>[6]; };
+
+        final boolean dedupe = updatedPositions != null;
+        if (block == null) block = world.getBlockType(pos);
+
+        final var qpos1 = new TilePos();
+        for (int i = 0; i < 6; i++) {
+            qpos1.set(pos).add(D1_OFFSETS[i]);
+            // ctx.D1_BLOCKS[i] = world.getBlockType(qpos1);
+
+            if (dedupe) {
+                if (updatedPositions.contains(qpos1)) continue;
+                updatedPositions.add(new TilePos(qpos1));
+            }
+
+            // ctx.D1_BLOCKS[i].onNeighborChanged(world, qpos1, block);
+            world.getBlockType(qpos1).onNeighborChanged(world, qpos1, block);
+        }
+        final var qpos2 = new TilePos();
+        for (int i = 0; i < 6; i++) {
+            qpos1.set(pos).add(D1_OFFSETS[i]);
+            for (final var d : D2_OFFSETS[i]) {
+                qpos2.set(qpos1).add(d);
+
+                if (dedupe) {
+                    if (updatedPositions.contains(qpos2)) continue;
+                    updatedPositions.add(new TilePos(qpos2));
+                }
+
+                // world.getBlockType(qpos2).onNeighborChanged(world, qpos2, ctx.D1_BLOCKS[i]);
+                world.getBlockType(qpos2).onNeighborChanged(world, qpos2, block);
+            }
+        }
+    }
+
+    public static void diamondD2Shell(
+        @NotNull World world, @NotNull TilePosc pos, @Nullable Block<?> block
+    ) {
+        diamondD2Shell(null, world, pos, block);
+    }
+
+    public static synchronized void diamondD2Shell(
+        @Nullable Set<@NotNull TilePosc> updatedPositions,
+        @NotNull World world, @NotNull TilePosc pos, @Nullable Block<?> block
+    ) {
+        // class ctx { static final Block<?>[] D1_BLOCKS = new Block<?>[6]; };
+
+        final boolean dedupe = updatedPositions != null;
+        if (block == null) block = world.getBlockType(pos);
+
+        final var qpos1 = new TilePos();
+        // for (int i = 0; i < 6; i++) {
+        //     qpos1.set(pos).add(D1_OFFSETS[i]);
+        //     // ctx.D1_BLOCKS[i] = world.getBlockType(qpos1);
+
+        //     if (dedupe) {
+        //         if (updatedPositions.contains(qpos1)) continue;
+        //         updatedPositions.add(new TilePos(qpos1));
+        //     }
+        // }
+        final var qpos2 = new TilePos();
+        for (int i = 0; i < 6; i++) {
+            qpos1.set(pos).add(D1_OFFSETS[i]);
+            for (final var d : D2_OFFSETS[i]) {
+                qpos2.set(qpos1).add(d);
+
+                if (dedupe) {
+                    if (updatedPositions.contains(qpos2)) continue;
+                    updatedPositions.add(new TilePos(qpos2));
+                }
+
+                // world.getBlockType(qpos2).onNeighborChanged(world, qpos2, ctx.D1_BLOCKS[i]);
+                world.getBlockType(qpos2).onNeighborChanged(world, qpos2, block);
+            }
+        }
+    }
+
+    /**
+     * similar to diamondUpdateD2, but only the blocks from the outer shell, that are adjascent
+     * to the block in the inner shell on the given direction, are updated.
+     */
+    public static void diamondD2SingleDir(
+        @NotNull Direction direction,
+        @NotNull World world, @NotNull TilePosc pos, @Nullable Block<?> block
+    ) {
+        diamondD2SingleDir(null, direction, world, pos, block);
+    }
+
+    public static void diamondD2SingleDir(
+        @Nullable Set<@NotNull TilePosc> updatedPositions,
+        @NotNull Direction direction,
+        @NotNull World world, @NotNull TilePosc pos, @Nullable Block<?> block
+    ) {
+        if (direction == Direction.NONE) {
+            diamondD1(updatedPositions, world, pos, block);
+            return;
+        }
+
+        final boolean dedupe = updatedPositions != null;
+        if (block == null) block = world.getBlockType(pos);
+
+        final var opposite = direction.opposite();
+        final var qpos = new TilePos();
+        
+        // Block<?> sideBlock = null;
+        for (int i = 0; i < 6; i++) {
+            final var d = D1_OFFSETS[i];
+            qpos.set(pos).add(d);
+
+            if (dedupe) {
+                if (updatedPositions.contains(qpos)) continue;
+                updatedPositions.add(new TilePos(qpos));
+            }
+
+            final var b = world.getBlockType(qpos);
+            // if (d == direction) sideBlock = b;
+
+            b.onNeighborChanged(world, qpos, block);
+        }
+        
+        // assert sideBlock != null;
+        for (int i = 0; i < 6; i++) {
+            final var d = D1_OFFSETS[i];
+            if (d == opposite) continue;
+            qpos.set(pos).add(direction).add(d);
+
+            if (dedupe) {
+                if (updatedPositions.contains(qpos)) continue;
+                updatedPositions.add(new TilePos(qpos));
+            }
+
+            final var b = world.getBlockType(qpos);
+            b.onNeighborChanged(world, qpos, block);
+            // b.onNeighborChanged(world, qpos, sideBlock);
+        }
+    }
+
+    /**
+     * updates blocks within the range |x| + |y| + |z| <= radius, excluding the origin.
+     * for every N's layer is updated with the N-1's layer as the source.
+     * for layers >= 3, the order no longer folows vanilla :(
+     */
+    public static void diamondDn(
+        int radius,
+        @NotNull World world, @NotNull TilePosc pos, @Nullable Block<?> block
+    ) {
+        diamondDn(null, radius, world, pos, block);
+    }
+
+    public static void diamondDn(
+        @Nullable Set<@NotNull TilePosc> updatedPositions,
+        int radius,
+        @NotNull World world, @NotNull TilePosc pos, @Nullable Block<?> block
+    ) {
+        if (radius <= 0) return;
+        if (block == null) block = world.getBlockType(pos);
+
+        switch (radius) {
+        case 1:
+            diamondD1(updatedPositions, world, pos, block);
+            break;
+        case 2:
+            diamondD2(updatedPositions, world, pos, block);
+            break;
+        default:
+            diamondD2(updatedPositions, world, pos, block);
+            final boolean dedupe = updatedPositions != null;
+            for (int shell = 3; shell <= radius; shell++) {
+                if (dedupe) {
+                    diamondDnShell(updatedPositions, shell, world, pos, block);
+                } else {
+                    diamondDnShell(shell, world, pos, block);
+                }
+            }
+            break;
+        }
+    }
+
+    public static record Diamond(@NotNull TilePos origin, int radius, @Nullable Block<?> block) {
+        public @NotNull Block<?> block(@NotNull World world) {
+            return (this.block != null)
+                ? this.block
+                : world.getBlockType(this.origin);
+        }
+    }
+
+    public static synchronized void diamondDnShell(
+        int radius,
+        @NotNull World world, @NotNull TilePosc pos, @Nullable Block<?> block
+    ) {
+        class ctx { static final ObjectOpenHashSet<TilePosc> POS_UPDATED = new ObjectOpenHashSet<>(); }
+        if (radius <= 0) return;
+
+        switch (radius) {
+        case 1:
+            diamondD1(world, pos, null);
+            return;
+        case 2:
+            diamondD2Shell(world, pos, null);
+            return;
+        }
+
+        final int LEN = 3 * radius * (radius - 1);
+        ctx.POS_UPDATED.clear();
+        ctx.POS_UPDATED.ensureCapacity(LEN);
+        
+        diamondDnShell(ctx.POS_UPDATED, radius, world, pos, block);
+        
+        ctx.POS_UPDATED.clear();
+        if (LEN >= 1024) ctx.POS_UPDATED.trim(512);
+    }
+
+    private static int sign(int n) { return (n == 0) ? 0 : (n < 0) ? -1 : 1; }
+
+    // TODO now that I know diamond updates should always pass the origin block
+    // TODO   as the update source, this can be made much more efficient
+    public static void diamondDnShell(
+        // This one cannot be null
+        @NotNull Set<@NotNull TilePosc> updatedPositions,
+        int radius,
+        @NotNull World world, @NotNull TilePosc pos, @Nullable Block<?> block
+    ) {
+        switch (radius) {
+        case 1:
+            diamondD1(updatedPositions, world, pos, null);
+            return;
+        case 2:
+            diamondD2Shell(updatedPositions, world, pos, null);
+            return;
+        }
+
+        radius --;
+        if (radius <= 0) return;
+
+        if (block == null) block = world.getBlockType(pos);
+
+        final TilePos s_query = new TilePos();
+        final TilePos t_query = new TilePos();
+
+        for (int x = -radius; x <= radius; x ++) {
+            final int x_sign = sign(x);
+            final int y_radius = radius - Math.abs(x); // 0, 1, 2, ... targetR, ... 2, 1, 0
+
+            for (int y = -y_radius; y <= y_radius; y++) {
+                final int y_sign = sign(y);
+                final int z_radius = y_radius - Math.abs(y);
+
+                for (int z = -z_radius; z <= z_radius; z++) { // [-1 0 1] or [0]
+                    final int z_sign = sign(z);
+
+                    s_query.set(pos).add(x, y, z_radius);
+
+                    for (final var dir : D1_OFFSETS) {
+                        final int dx_sign = sign(dir.offsetX());
+                        final int dy_sign = sign(dir.offsetY());
+                        final int dz_sign = sign(dir.offsetZ());
+
+                        if (Math.abs(x_sign - dx_sign) > 1) continue;
+                        if (Math.abs(y_sign - dy_sign) > 1) continue;
+                        if (Math.abs(z_sign - dz_sign) > 1) continue;
+
+                        // t_query.set(s_query).add(dir);
+
+                        if (updatedPositions.contains(t_query)) continue;
+                        updatedPositions.add(new TilePos(t_query));
+
+                        // final var sblock = world.getBlockType(s_query);
+                        final var tblock = world.getBlockType(t_query);
+                        tblock.onNeighborChanged(world, t_query, block);
+                    }
+                }
+            }
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/Side.java b/game/core/src/main/java/net/minecraft/core/util/helper/Side.java
index 84e23ab63..3c497cc9b 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/Side.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/Side.java
@@ -4,13 +4,20 @@ import org.jetbrains.annotations.NotNull;
 
 public enum Side {
 	
-	TOP(Axis.Y, 0, 1, 0, "top"),
-	BOTTOM(Axis.Y, 0, -1, 0, "bottom"),
-	NORTH(Axis.Z, 0, 0, -1, "north"),
-	EAST(Axis.X, 1, 0, 0, "east"),
-	SOUTH(Axis.Z, 0, 0, 1, "south"),
-	WEST(Axis.X, -1, 0, 0, "west"),
-	NONE(Axis.NONE, 0, 0, 0, "none");
+	BOTTOM(Direction.DOWN, "bottom"),
+	TOP(Direction.UP, "top"),
+	NORTH(Direction.NORTH, "north"),
+	SOUTH(Direction.SOUTH, "south"),
+	WEST(Direction.WEST, "west"),
+	EAST(Direction.EAST, "east"),
+
+    /**
+     * Method implementations might not guarantee correct behaviour (error safety) when passed
+     * Side.NONE. Prefer passing {@code null} if method accepts {@code @Nullable Side},
+     * or an acceptable default side, or avoid calling the method entirely!
+     */
+	@Deprecated
+	NONE(Direction.NONE, "none");
 	
 	public static final Side posX = EAST;
 	public static final Side negX = WEST;
@@ -19,106 +26,64 @@ public enum Side {
 	public static final Side posZ = SOUTH;
 	public static final Side negZ = NORTH;
 	
-	public static final Side[] sides = new Side[6];
-	
-	static {
-		setId(BOTTOM, 0);
-		setId(TOP, 1);
-		setId(NORTH, 2);
-		setId(SOUTH, 3);
-		setId(WEST, 4);
-		setId(EAST, 5);
-		NONE.id = -1;
-		
-		setOpposites(EAST, WEST);
-		setOpposites(TOP, BOTTOM);
-		setOpposites(NORTH, SOUTH);
-		NONE.opposite = NONE;
-		
-		TOP.direction = Direction.UP;
-		BOTTOM.direction = Direction.DOWN;
-		NORTH.direction = Direction.NORTH;
-		EAST.direction = Direction.EAST;
-		SOUTH.direction = Direction.SOUTH;
-		WEST.direction = Direction.WEST;
-		NONE.direction = Direction.NONE;
-	}
-	
-	private static void setId(Side side, int id) {
-		sides[id] = side;
-		side.id = id;
-	}
-	
-	private static void setOpposites(Side side1, Side side2) {
-		side1.opposite = side2;
-		side2.opposite = side1;
-	}
+	public static final Side[] sides = {
+		BOTTOM, TOP,
+		NORTH, SOUTH,
+		WEST, EAST,
+	};
 	
 	/////////////////////
 	
-	public static Side getSideById(int i) {
-		if(i >= 0 && i < sides.length) {
-			return sides[i];
-		}else {
-			return NONE;
-		}
+	public static Side fromId(int i) {
+		return (i >= 0 && i < 6)
+			? sides[i]
+			: Side.NONE;
 	}
-	
+
 	/////////////////////
 
-	private final Axis axis;
-	private int id;
-	private Side opposite;
-	private Direction direction;
-	
-	private final int offsetX;
-	private final int offsetY;
-	private final int offsetZ;
+	public final int id;
+	public final @NotNull Direction direction;
 
-	private final String translationKey;
+	// Why arent we using this
+	private final @NotNull String translationKey;
 	
-	Side(Axis axis, int offsetX, int offsetY, int offsetZ, String translationKey) {
-		this.axis = axis;
-		this.offsetX = offsetX;
-		this.offsetY = offsetY;
-		this.offsetZ = offsetZ;
+	Side(@NotNull Direction direction, @NotNull String translationKey) {
+		this.direction = direction;
+		this.id = direction.id;
 		this.translationKey = translationKey;
 	}
 	
-	public int getOffsetX() {
-		return offsetX;
+	public int offsetX() {
+		return this.direction.offsetX();
 	}
 	
-	public int getOffsetY() {
-		return offsetY;
+	public int offsetY() {
+		return this.direction.offsetY();
 	}
 	
-	public int getOffsetZ() {
-		return offsetZ;
+	public int offsetZ() {
+		return this.direction.offsetZ();
 	}
 	
-	public @NotNull Side getOpposite() {
-		return opposite;
+	public @NotNull Side opposite() {
+		return sides[this.id ^ 1];
 	}
 	
-	public @NotNull Direction getDirection() {
-		return direction;
+	public @NotNull Direction direction() {
+		return this.direction;
 	}
 	
-	public @NotNull Axis getAxis() {
-		return axis;
+	public @NotNull Axis axis() {
+		return this.direction.axis();
 	}
 	
-	public int getId() {
-		return id;
-	}
-
 	public boolean isVertical() {
-		return getAxis().isVertical();
+		return this.direction.isVertical();
 	}
 	
 	public boolean isHorizontal() {
-		return !isVertical();
+		return this.direction.isHorizontal();
 	}
 	
 }
diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/Sides.java b/game/core/src/main/java/net/minecraft/core/util/helper/Sides.java
index a282369be..98c668058 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/Sides.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/Sides.java
@@ -16,6 +16,7 @@ public class Sides
 	public static final int negX = 4;
 	public static final int posX = 5;
 
+	// TODO replace with Direction.rotate<X | Y | Z>
 	public static final int[] orientationLookUpHorizontal = {
 			bottom, top, south, north, west, east,
 			bottom, top, south, north, west, east,
diff --git a/game/core/src/main/java/net/minecraft/core/world/ICarriable.java b/game/core/src/main/java/net/minecraft/core/world/ICarriable.java
index d2a19fd8d..da753bdeb 100644
--- a/game/core/src/main/java/net/minecraft/core/world/ICarriable.java
+++ b/game/core/src/main/java/net/minecraft/core/world/ICarriable.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.block.motion.CarriedBlock;
+import net.minecraft.core.block.piston.CarriedPistonHead;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.Side;
 import org.slf4j.Logger;
@@ -11,9 +12,10 @@ public interface ICarriable {
     Logger LOGGER = LogUtils.getLogger();
     /**
      * Called every tick an entity holds this object
-     */
-    void heldTick(World world, Entity holder);
-
+    */
+   void heldTick(World world, Entity holder);
+   
+    // TODO TilePos refactor
     /**
      * Called by the entity when trying to place the held object at some position
      * @return True if carried object could place, false otherwise
@@ -33,13 +35,17 @@ public interface ICarriable {
 
     void readFromNBT(CompoundTag tag);
 
-    String TYPE_BLOCK = "block";
+    static final String TYPE_BLOCK = "block";
+    static final String TYPE_PISTON_HEAD = "block/piston_head";
 
     static ICarriable createAndLoadCarriable(Entity holder, CompoundTag tag) {
         String type = tag.getString("type");
         if (type.equalsIgnoreCase(TYPE_BLOCK)) {
             return CarriedBlock.createAndLoadCarriedBlock(holder, tag);
         }
+        if (type.equalsIgnoreCase(TYPE_PISTON_HEAD)) {
+            return CarriedPistonHead.createAndLoad(tag);
+        }
         LOGGER.warn("Could not identify carriable for type {}!", type);
         return null;
     }
